Bug 1737955 - exaile depends on Python 2
Summary: exaile depends on Python 2
Keywords:
Status: CLOSED DUPLICATE of bug 1777624
Alias: None
Product: Fedora
Classification: Fedora
Component: exaile
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Christian Stadelmann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F31_PY2REMOVAL
TreeView+ depends on / blocked
 
Reported: 2019-08-06 12:06 UTC by Lumír Balhar
Modified: 2021-07-12 13:55 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-11-28 01:10:18 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github exaile exaile issues 246 0 'None' 'open' 'Migration to Python3' 2019-12-07 07:52:14 UTC

Description Lumír Balhar 2019-08-06 12:06:28 UTC
Python 2.7 will reach end-of-life in January 2020, over 9 years after it was released. This falls within the Fedora 31 lifetime.
Packages that depend on Python 2 are being switched to Python 3 or removed from Fedora: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages
Python 2 will be retired in Fedora 32: https://fedoraproject.org/wiki/Changes/RetirePython2

To help planning, we'd like to know the plans for exaile's future. Specifically:


- What is the reason for the Python2 dependency? (Is it software written in Python, or does it just provide Python bindings, or use Python in the build system or test runner?) 

- What are the upstream/community plans/timelines regarding Python 3?

- What is the guidance for porting to Python 3? (Assuming that there is someone who generally knows how to port to Python 3, but doesn't know anything about the particular package, what are the next steps to take?)


This bug is filed semi-automatically, and might not have all the context specific to exaile.
If you need anything from us, or something is unclear, please mention it here.

Thank you.

Comment 1 Christian Stadelmann 2019-08-06 17:45:34 UTC
(In reply to Lumír Balhar from comment #0)
> To help planning, we'd like to know the plans for exaile's future.
> Specifically:
> 
> - What is the reason for the Python2 dependency? (Is it software written in
> Python, or does it just provide Python bindings, or use Python in the build
> system or test runner?) 

Exaile is written in Python 2 and has 2 optional dependencies available only in python 2 (python-CDDB, to be replaced by a different library soon; python2-spydaap which is not even packaged for Fedora).

> - What are the upstream/community plans/timelines regarding Python 3?

There is no timeline, only a vague plan. See https://github.com/exaile/exaile/issues/246
 
> - What is the guidance for porting to Python 3? (Assuming that there is
> someone who generally knows how to port to Python 3, but doesn't know
> anything about the particular package, what are the next steps to take?)

If you want to contribute, please see https://github.com/exaile/exaile/issues/246

Comment 2 Ben Cotton 2019-08-13 17:05:52 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 3 leigh scott 2019-08-13 19:01:33 UTC
(In reply to Ben Cotton from comment #2)
> This bug appears to have been reported against 'rawhide' during the Fedora
> 31 development cycle.
> Changing version to '31'.

Moved to back to rawhide as this won't be addressed in f31 release cycle.

Comment 4 Lumír Balhar 2019-08-21 13:40:36 UTC
Thank you for the info.

The current plan is to remove packages with dependency on Python 2 from Fedora 32 in the middle of November 2019. If you want to keep your package in Fedora after that date and you cannot port it to Python 3 yet, you need to request a FESCo exception for the package and all its Python 2 dependencies (even transitive) [1]. If you don't want to maintain it anymore, and nothing in Fedora uses it, you can retire it or just remove the Python 2 part from it (subpackage, module, bindings, etc.).

If you're considering filing the exception request, let us know. We can help (for example, we can help find all the dependencies).

[1] https://fedoraproject.org/wiki/Changes/RetirePython2#FESCo_exceptions

Comment 5 leigh scott 2019-08-21 14:01:41 UTC
If upstream doesn't port to python3 in time for that I will have to retire it.

Comment 6 Adam Williamson 2019-11-27 18:28:08 UTC
This is now broken on Rawhide:

DEBUG util.py:596:  2019-11-27 07:49:56,797: Problem: conflicting requests
DEBUG util.py:596:  2019-11-27 07:49:56,798: - nothing provides python2-gstreamer1 >= 1.4 needed by exaile-4.0.0-3.fc31.noarch.
DEBUG util.py:596:  2019-11-27 07:49:56,798: 

it is breaking the MATE live image build.

https://github.com/exaile/exaile/issues/608 seems to be discussed upstream as the 'last' Python 2-only dependency. There is a PR open but not merged that has not been touched since August: https://github.com/exaile/exaile/pull/652

Since it looks like this isn't moving very fast upstream, I think we should drop Exaile from the MATE image to make it build again. Not sure what should replace it. CCing raveit65 (MATE spin maintainer) for that.

Comment 7 Adam Williamson 2019-11-27 18:43:26 UTC
This also affects the Cinnamon live image, so CCing Dan. Dan, fedora-cinnamon-common.ks includes exaile and that means Cinnamon image builds fail in current Rawhide because of this bug, it probably needs replacing.

Comment 8 Miro Hrončok 2019-11-28 01:10:18 UTC

*** This bug has been marked as a duplicate of bug 1777624 ***

Comment 9 Christian Stadelmann 2020-01-22 18:59:16 UTC
Is there any chance to get it back if upstream manages to get it ported to python3? If yes, when would be the deadline?

Comment 10 Miro Hrončok 2020-01-22 23:10:06 UTC
Yes, if we get it Python 3 based, we can get it back.

Withing 8 weeks of retirement, we can get i back without a Fedora review. But we can get it back with a review any time. I'll gladly do the review, juts ping me when ready.


If we want to have it back withing Fedora 32 release, the deadline is Final Freeze: 2020-04-07

https://fedorapeople.org/groups/schedule/f-32/f-32-key-tasks.html

Comment 11 Graham White 2021-07-12 13:55:19 UTC
Just to note that I have taken over maintenance for Exaile and I'm currently in the process of bringing it back to the current release branches.


Note You need to log in before you can comment on or make changes to this bug.